cascading.operation.aggregator

## Class Average

- java.lang.Object
- - cascading.operation.BaseOperation<Average.Context>
  - - cascading.operation.aggregator.Average

All Implemented Interfaces:
  DeclaresResults, Aggregator<Average.Context>, Operation<Average.Context>, Traceable, java.io.Serializable

    public class Average
    extends BaseOperation<Average.Context>
    implements Aggregator<Average.Context>

Class Average is an `Aggregator` that returns the average of all numeric values in the current group.

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`protected static class` `Average.Context` Class Context is used to hold intermediate values.

### Field Summary

Fields
`static java.lang.String` `FIELD_NAME` Field FIELD_NAME

### Fields inherited from class cascading.operation.BaseOperation

`fieldDeclaration, numArgs, trace`

### Fields inherited from interface cascading.operation.Operation

`ANY`

### Constructor Summary

Constructors
Constructor and Description
`Average()` Constructs a new instance that returns the average of the values encountered in the field name "average".
`Average(Fields fieldDeclaration)` Constructs a new instance that returns the average of the values encountered in the given fieldDeclaration field name.

### Method Summary

Methods
`void` `aggregate(FlowProcess flowProcess, AggregatorCall<Average.Context> aggregatorCall)` Method aggregate is called for each `TupleEntry` value in the current grouping.
`void` `complete(FlowProcess flowProcess, AggregatorCall<Average.Context> aggregatorCall)` Method complete will be issued last after every `TupleEntry` has been passed to the `Aggregator.aggregate(cascading.flow.FlowProcess, AggregatorCall)` method.
`void` `prepare(FlowProcess flowProcess, OperationCall<Average.Context> operationCall)` Method prepare does nothing, and may safely be overridden.
`void` `start(FlowProcess flowProcess, AggregatorCall<Average.Context> aggregatorCall)` Method start initializes the aggregation procedure and is called for every unique grouping.

### Methods inherited from class cascading.operation.BaseOperation

`cleanup, equals, flush, getFieldDeclaration, getNumArgs, getTrace, hashCode, isSafe, printOperationInternal, toString, toStringInternal`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface cascading.operation.Operation

`cleanup, flush, getFieldDeclaration, getNumArgs, isSafe`

### Field Detail

#### FIELD_NAME

    public static final java.lang.String FIELD_NAME

Field FIELD_NAME

See Also:
  Constant Field Values

### Constructor Detail

#### Average

    public Average()

Constructs a new instance that returns the average of the values encountered in the field name "average".

#### Average

    @ConstructorProperties(value="fieldDeclaration")
    public Average(Fields fieldDeclaration)

Constructs a new instance that returns the average of the values encountered in the given fieldDeclaration field name.

Parameters:
  `fieldDeclaration` - of type Fields

### Method Detail

#### prepare

    public void prepare(FlowProcess flowProcess,
               OperationCall<Average.Context> operationCall)

Description copied from class: `BaseOperation`
Method prepare does nothing, and may safely be overridden.

Specified by:
  `prepare` in interface `Operation<Average.Context>`
Overrides:
  `prepare` in class `BaseOperation<Average.Context>`

#### start

    public void start(FlowProcess flowProcess,
             AggregatorCall<Average.Context> aggregatorCall)

Description copied from interface: `Aggregator`
Method start initializes the aggregation procedure and is called for every unique grouping.

The AggregatorCall context should be initialized here if necessary.

The first time this method is called for a given 'process', the AggregatorCall context will be null. This method should set a new instance of the user defined context object. When the AggregatorCall context is not null, it is up to the developer to create a new instance, or 'recycle' the given instance. If recycled, it must be re-initialized to remove any previous state/values.

For example, if a Map is used to hold the intermediate data for each subsequent `Aggregator.aggregate(cascading.flow.FlowProcess, AggregatorCall)` call, new HashMap() should be set on the AggregatorCall instance when `OperationCall.getContext()` is null. On the next grouping, start() will be called again, but this time with the old Map instance. In this case, map.clear() should be invoked before returning.

Specified by:
  `start` in interface `Aggregator<Average.Context>`
Parameters:
  `flowProcess` - of type FlowProcess
  `aggregatorCall` - of type AggregatorCall

#### aggregate

    public void aggregate(FlowProcess flowProcess,
                 AggregatorCall<Average.Context> aggregatorCall)

Description copied from interface: `Aggregator`
Method aggregate is called for each `TupleEntry` value in the current grouping.

TupleEntry entry, or entry.getTuple() should not be stored directly in the context. A copy of the tuple should be made via the `new Tuple( entry.getTuple() )` copy constructor.

Specified by:
  `aggregate` in interface `Aggregator<Average.Context>`
Parameters:
  `flowProcess` - of type FlowProcess
  `aggregatorCall` - of type AggregatorCall

#### complete

    public void complete(FlowProcess flowProcess,
                AggregatorCall<Average.Context> aggregatorCall)

Description copied from interface: `Aggregator`
Method complete will be issued last after every `TupleEntry` has been passed to the `Aggregator.aggregate(cascading.flow.FlowProcess, AggregatorCall)` method. Any final calculation should be completed here and passed to the outputCollector.

Specified by:
  `complete` in interface `Aggregator<Average.Context>`
Parameters:
  `flowProcess` - of type FlowProcess
  `aggregatorCall` - of type AggregatorCall